TYPOS3.Flow - Bug # 31363

Status: Resolved Priority: Should have
Author: Christof Rodejohann Category: Reflection

Created: 2011-10-27 Assigned To: Karsten Dambekalns
Updated: 2011-12-21 Due date:

PHP Version:

Has patch: No

Complexity:

Affected Flow version: FLOW3 1.0.0

Subject: Windows newline in annotation block throws exception

Description

If a class annotation contains Windows newline character instead of the expected UNIX version, FLOW3 will quit with an Uncaught

Exception.

Because of this a fresh clone from /FLOW3/Distributions/Base.git might fail under some circumstances (Windows and git config

"core.autocrlf = true"). This can be avoided with a correct git configuration, which is now documented in the wiki (

http:/forge.typo3.org/projects/flow3/wiki/Installation _hints8 ). An example exception thrown by this configuration can be found here:

http://pastebin.de/raw/?id=19666 and the bug under http://forge.typo3.org/issues/31087 is related to this issue.

The expected behavior is FLOW3 working with Windows new-line in annotations block.

PS: Thx to the #flow3 IRC channel and afoeder for figuring this out.

Related issues:
related to TYPOS.Flow - Bug # 32466: Strange exception: Invalid annotation Resolved

2011-12-12

Associated revisions

Revision 40af60c9 - 2011-12-15 17:25 - Karsten Dambekalns

[BUGFIX] "Wrong" EOL characters break parsing of doc comments

When \r\n was used as EOL instead of just \n the parsed doc comments
would retain the \r which would cause confusing exceptions in some

cases later on.

Change-Id: 1632ced42f1f337cb7546ed411bcfde2e92011c2e
Fixes: #31363

Related: #32466

Related: #31087

Releases: 1.0, 1.1

Revision 6¢ca1f9b2 - 2011-12-20 14:51 - Karsten Dambekalns

[BUGFIX] "Wrong" EOL characters break parsing of doc comments

When \r\n was used as EOL instead of just \n the parsed doc comments

would retain the \r which would cause confusing exceptions in some

cases later on.
http://forge.typo3.org/projects/flow3/wiki/Installation_hints8
http://pastebin.de/raw/?id=19666
http://forge.typo3.org/issues/31087

Change-Id: 15210bb5308558640f7b1e567eaf9a184c1f5a2d5
Fixes: #31363

Related: #32466

Related: #31087

Releases: 1.0, 1.1

History

#1 - 2011-10-27 21:47 - Christof Rodejohann

Having trouble with my git environment, so i can't push the patch. The solution is a one-line change in

Packages\Framework\TYPO3.FLOW3\Classes\Reflection\DocCommentParser.php

In Line 50, the $line has to be stripped of all newline characters. Adding the following line there will fix the bug:

$line = str_replace(array("\r\n", "\n", "\r"), ", $line);

#2 - 2011-12-14 15:43 - Karsten Dambekalns
- Category set to Reflection

- Status changed from New to Accepted

- Assigned To set to Karsten Dambekalns

- Target version set to 1.0.2

#3 - 2011-12-15 17:25 - Gerrit Code Review

- Status changed from Accepted to Under Review

Patch set 1 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/7287

#4 - 2011-12-20 14:36 - Karsten Dambekalns
- Status changed from Under Review to Resolved

- % Done changed from 0 to 100

Applied in changeset commit:40af60c9d7013757b4f980daf31b038c494e6f6a.

#5 - 2011-12-20 14:51 - Gerrit Code Review

- Status changed from Resolved to Under Review

Patch set 1 for branch FLOW3-1.0 has been pushed to the review server.
It is available at http://review.typo3.org/7435

#6 - 2011-12-21 17:06 - Karsten Dambekalns

- Status changed from Under Review to Resolved
Applied in changeset commit:6ca1f9b2734e083f0f707af0d2f83f7bf5da87de.
